variables:
  GOLANGCI_LINT_VERSION: "v1.60.1"
  OUTPUT_NAME: __bin__/$CI_PROJECT_NAME
  GCO_ENABLED: 0

image: golang:latest

stages:
  - lint
  - test
  - build
  # - release

package:
  stage: build
  script:
    - make package
  artifacts:
    paths:
      - dist/

test:
  stage: test
  script:
    - go vet $(go list ./... | grep -v /vendor/)
    - go test -race $(go list ./... | grep -v /vendor/)

govulncheck:
  stage: test
  script:
    - go run golang.org/x/vuln/cmd/govulncheck ./...

staticcheck:
  stage: test
  script:
    - go run honnef.co/go/tools/cmd/staticcheck ./...

# Source: https://akyriako.medium.com/build-golang-docker-images-with-gitlab-ci-pipelines-2117f8505350
lint:
  image: golangci/golangci-lint:$GOLANGCI_LINT_VERSION
  stage: lint
  extends: .go-cache
  allow_failure: false
  script:
    - golangci-lint run -v

.go-cache:
  variables:
    GOPATH: $CI_PROJECT_DIR/.go
  cache:
    paths:
      - .go/pkg/mod/
